package com.logicbig.example;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public class MergingDetachedProxyEntity {

    public static void main(String[] args) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("example-unit");
        try {
            persistEntity(emf);
            Employee employee = getEntityReference(emf);
            EntityManager em = emf.createEntityManager();
            employee = em.merge(employee);
            System.out.println("employee name " + employee.getName());
            em.close();
        } finally {
            emf.close();
        }
    }

    private static Employee persistEntity(EntityManagerFactory emf) {
        Employee employee = new Employee("Sara Dorsey", "Admin");
        System.out.println("-- persisting employee --");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        em.persist(employee);
        em.getTransaction().commit();
        em.close();
        System.out.println("Employee persisted: " + employee);
        return employee;
    }

    private static Employee getEntityReference(EntityManagerFactory emf) {
        EntityManager em = emf.createEntityManager();
        Employee employee = em.getReference(Employee.class, 1);
        em.close();
        return employee;
    }
}